Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1411054 - Review Request: nodejs-needle - The leanest and most handsome HTTP client in the Nodelands
Summary: Review Request: nodejs-needle - The leanest and most handsome HTTP client in ...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Tom Hughes
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1411053
Blocks: nodejs-reviews Node-RED
TreeView+ depends on / blocked
 
Reported: 2017-01-07 22:21 UTC by Jared Smith
Modified: 2017-04-07 15:44 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-04-07 15:44:05 UTC
tom: fedora-review+


Attachments (Terms of Use)

Description Jared Smith 2017-01-07 22:21:06 UTC
Spec URL: https://jsmith.fedorapeople.org/Packaging/nodejs-needle/nodejs-needle.spec
SRPM URL: https://jsmith.fedorapeople.org/Packaging/nodejs-needle/nodejs-needle-1.4.3-1.fc26.src.rpm
Description: The leanest and most handsome HTTP client in the Nodelands
Fedora Account System Username: jsmith

Comment 1 Tom Hughes 2017-03-18 11:29:37 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 41 files have
     unknown license. Detailed output of licensecheck in /home/tom/1411054
     -nodejs-needle/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 10 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nodejs-needle-1.4.3-1.fc27.noarch.rpm
          nodejs-needle-1.4.3-1.fc27.src.rpm
nodejs-needle.noarch: W: only-non-binary-in-usr-lib
nodejs-needle.noarch: W: dangling-symlink /usr/lib/node_modules/needle/node_modules/iconv-lite /usr/lib/node_modules/iconv-lite
nodejs-needle.noarch: W: wrong-file-end-of-line-encoding /usr/share/doc/nodejs-needle/examples/parsed-stream2.js
nodejs-needle.noarch: W: dangling-symlink /usr/lib/node_modules/needle/node_modules/debug /usr/lib/node_modules/debug
nodejs-needle.noarch: W: no-manual-page-for-binary needle
2 packages and 0 specfiles checked; 0 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
nodejs-needle.noarch: W: only-non-binary-in-usr-lib
nodejs-needle.noarch: W: dangling-symlink /usr/lib/node_modules/needle/node_modules/debug /usr/lib/node_modules/debug
nodejs-needle.noarch: W: dangling-symlink /usr/lib/node_modules/needle/node_modules/iconv-lite /usr/lib/node_modules/iconv-lite
nodejs-needle.noarch: W: wrong-file-end-of-line-encoding /usr/share/doc/nodejs-needle/examples/parsed-stream2.js
nodejs-needle.noarch: W: no-manual-page-for-binary needle
1 packages and 0 specfiles checked; 0 errors, 5 warnings.



Requires
--------
nodejs-needle (rpmlib, GLIBC filtered):
    /usr/bin/node
    nodejs
    nodejs(engine)
    npm(debug)
    npm(iconv-lite)



Provides
--------
nodejs-needle:
    nodejs-needle
    npm(needle)



Source checksums
----------------
https://registry.npmjs.org/needle/-/needle-1.4.3.tgz :
  CHECKSUM(SHA256) this package     : 21659dbfdf90489e85435625ad9c29dfadee00ffb0f0d795184af5bd760a5f7f
  CHECKSUM(SHA256) upstream package : 21659dbfdf90489e85435625ad9c29dfadee00ffb0f0d795184af5bd760a5f7f


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -m compton-rawhide-x86_64 -b 1411054
Buildroot used: compton-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 2 Tom Hughes 2017-03-18 11:31:32 UTC
There's a format error in the first changelog entry (a missing hyphen).

There's a newer version (1.5.2) available.

There's no reason not to run the tests - you just need to require openssl and then generate a certificate. Instructions are in the readme but an enhanced version that sets the subject to stop it prompting is:

mkdir -p test/keys
openssl genrsa -out test/keys/ssl.key 2048
openssl req -new -key test/keys/ssl.key -x509 -subj /CN=test@example.com -days 999 -out test/keys/ssl.cert

After that the tests run though I am seeing a few failures:

  1) with output option and a 200 response for a binary file uses a writableStream:
     Uncaught TypeError: pixel.binarySlice is not a function
      at handler (test/output_spec.js:188:27)
      at Server.<anonymous> (test/output_spec.js:35:7)
      at HTTPParser.parserOnIncoming [as onIncoming] (_http_server.js:546:12)
      at HTTPParser.parserOnHeadersComplete (_http_common.js:99:23)

  2) with output option and a 200 response for a binary file writes a file:
     Uncaught TypeError: pixel.binarySlice is not a function
      at handler (test/output_spec.js:188:27)
      at Server.<anonymous> (test/output_spec.js:35:7)
      at HTTPParser.parserOnIncoming [as onIncoming] (_http_server.js:546:12)
      at HTTPParser.parserOnHeadersComplete (_http_common.js:99:23)

  3) with output option and a 200 response for a binary file file size equals response length:
     Uncaught TypeError: pixel.binarySlice is not a function
      at handler (test/output_spec.js:188:27)
      at Server.<anonymous> (test/output_spec.js:35:7)
      at HTTPParser.parserOnIncoming [as onIncoming] (_http_server.js:546:12)
      at HTTPParser.parserOnHeadersComplete (_http_common.js:99:23)

  4) with output option and a 200 response for a binary file file is equal to original buffer:
     Uncaught TypeError: pixel.binarySlice is not a function
      at handler (test/output_spec.js:188:27)
      at Server.<anonymous> (test/output_spec.js:35:7)
      at HTTPParser.parserOnIncoming [as onIncoming] (_http_server.js:546:12)
      at HTTPParser.parserOnHeadersComplete (_http_common.js:99:23)

  5) with output option and a 200 response for a binary file returns the data in resp.body too:
     Uncaught TypeError: pixel.binarySlice is not a function
      at handler (test/output_spec.js:188:27)
      at Server.<anonymous> (test/output_spec.js:35:7)
      at HTTPParser.parserOnIncoming [as onIncoming] (_http_server.js:546:12)
      at HTTPParser.parserOnHeadersComplete (_http_common.js:99:23)

  6) with output option and a 200 response for a binary file closes the file descriptor:
     Uncaught TypeError: pixel.binarySlice is not a function
      at handler (test/output_spec.js:188:27)
      at Server.<anonymous> (test/output_spec.js:35:7)
      at HTTPParser.parserOnIncoming [as onIncoming] (_http_server.js:546:12)
      at HTTPParser.parserOnHeadersComplete (_http_common.js:99:23)

Comment 3 Jared Smith 2017-03-24 18:00:33 UTC
I've fixed all of the "pixel.binarySlice is not a function" issues in the tests, and simply commented out the "TypeError: Request path contains unescaped characters" test, as it's actually complaining about the very error that the test is intended to catch.

I also updated to the 1.5.2 version and fixed the typo in the spec file. 

Spec URL: https://jsmith.fedorapeople.org/Packaging/nodejs-needle/nodejs-needle.spec
SRPM URL: https://jsmith.fedorapeople.org/Packaging/nodejs-needle/nodejs-needle-1.5.2-1.fc27.src.rpm

Comment 4 Tom Hughes 2017-03-24 18:57:04 UTC
Looks good now, though obviously we need to get jschardet in before the tests can be run.

Comment 5 Gwyn Ciesla 2017-03-25 16:34:34 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/nodejs-needle


Note You need to log in before you can comment on or make changes to this bug.